/*
Copyright (C) 2007 - Nastasi Christian
This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/

/**
 *\file CXor.cpp
 *\brief CXor decoder development functions
 */
 
#include "CXor.h"
#include <iostream>

s_ret CXor::getDefinition(struct SDef def){
	if(def.s_Option == NULL)
		return S_OPTION_ERR;
	else
		xor_Esc = (unsigned char)def.s_Option->o_Esc;
	return S_RET_OK;
}

//Decode function
s_ret CXor::retStream(unsigned char *buffer_i, unsigned long length_i, unsigned char **buffer_o, unsigned long *length_o){
	std::vector<unsigned char>	buff;

	buff.clear();
	
	for(unsigned long i = 0; i < length_i; i++){
		//actual byte is esc char!!
		if(*(buffer_i + i) == xor_Esc){
			buff.push_back((*(buffer_i + i + 1)) ^ xor_Esc);
			i++;
			if(i == length_i){
				return S_D_ESCAPE_ERR;
			}
		}else{ //normal char
			buff.push_back(*(buffer_i + i));
		}
	}
		
	*length_o = buff.size();
	*buffer_o = new unsigned char[*length_o];
	
	for(unsigned long i = 0; i < *length_o; i++){
		(*buffer_o)[i] = (unsigned char)buff[i];
		#ifdef DEBUG
		std::cerr << "Character after xor decoder: " << std::dec << (int)(*buffer_o)[i] << std::endl;
		#endif
	}
	
	return S_RET_OK;
	
}

